#include <vector>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

namespace Personagens
{
    class Personagem
    {
    private:
        int x;
        static int MAX;

    public:

        Personagem():
            x ( -1 )
        {
            time_t t;
            srand((unsigned) time(&t));

            int pos = rand()%(Personagem::getMAX());
            cout << "Numero aleattio: " << pos << endl;
            setX(pos);
        }

        virtual ~Personagem()
        {
        }

        void setX(const int _x) { x = _x; }
        const int getX() const { return x; }

        static void setMAX(const int m) { MAX = m; }
        static const int getMAX() { return MAX; }

        virtual void movimentar() = 0;
    };
    int Personagem::MAX ( 0 );

    class BoiTata;

    class Curupira : public Personagem
    {
    private:
        bool empoderado;
        bool avancar; // avanar
        int  nvidas;

    public:
        Curupira(const bool av = true) :
            Personagem (  ),
            avancar ( av )
        {

            empoderado = rand()%2;
            //cout << "Numero aleattio: " << empoderado << endl;

            nvidas = getMAX();
        }

        ~Curupira()
        {
        }

        const bool getEmpoderado() const
        {
            return empoderado;
        }

        const int getNVidas() const
        {
            return nvidas;
        }

        void setNvidas(const int nv)
        {
            nvidas = nv;
        }

        void movimentar()
        {
            if (avancar)
            {
                if (getX() < getMAX())
                {
                    setX(getX()+1);
                }
                else
                {
                    avancar = false;
                    setX(getX()-1);
                }
            }
            else
            {
                if (getX() > 0)
                {
                    setX(getX()-1);
                }
                else
                {
                    avancar = true;
                    setX(getX()+1);
                }
            }
        }

        void atacar(BoiTata* pBoiTata);
    };

    class BoiTata : public Personagem
    {
    private:
        int energia;
        Curupira* pCurupira;;

    public:

        BoiTata(Curupira* pCur = NULL, const int energ = 0):
            Personagem  ( ),
            pCurupira   ( pCur ),
            energia     ( energ )
        {
        }

        ~BoiTata()
        {
        }

        const int getEnergia() const { return energia; }

        void movimentar()
        {
            if ( pCurupira )
            {
                if ( getX() > pCurupira->getX())
                {
                    setX(getX()-1);
                }
                else
                {
                    setX(getX()+1);
                }
                atacar();
            }
            else
            {
                cout << "Ponteiro pCurupira nulo em BoiTata. " << endl;
            }
        }

        void operator--()
        {
            energia--;
        }

        void atacar();
    };

    void Curupira::atacar(BoiTata* pBoiTata)
    {
        if (pBoiTata)
        {
            pBoiTata->operator--();
        }
    }

     void BoiTata::atacar()
    {
        if (pCurupira)
        {
            if ( pCurupira->getX() == getX() )
            {
                if ( pCurupira->getEmpoderado() )
                {
                    pCurupira->atacar(this);
                }
                else
                {
                    energia++;
                    int decrementa = pCurupira->getNVidas()-1;
                    pCurupira->setNvidas(decrementa);
                }
            }
        }
        else
        {
            cout << "Ponteiro de Curupira nulo" << endl;
        }
    }

}

using namespace Personagens;

namespace Gerenciadores
{
    class VetorPersonagens
    {
    private:
        vector<Personagem*> personagens;
        vector<Personagem*>::iterator itPersonagens;

    public:

        VetorPersonagens()
        {
            personagens.clear();
        }

        ~VetorPersonagens()
        {
            personagens.clear();
        }

        void inserir(Personagens::Personagem* p)
        {
            if ( p )
            {
                personagens.push_back( p );
            }
            else
            {
                cout << "Ponteiro p de Personagem vazio em VetorPersonagens." << endl;
            }
        }

        Personagem* operator[](const int idx)
        {
            int tam = 0;
            tam = (int)personagens.size();

            if ( (idx >= 0) && (idx < tam) )
            {
                itPersonagens = personagens.begin();
                for (int i = 0; i < idx; i++)
                {
                    itPersonagens++;
                }
                return *itPersonagens;
            }
            else
            {
                cout << "Operador de colchetes operando foram dos limites." << endl;
                return NULL;
            }
        }

        Personagem* excluir(int idx)
        {
            int tam = 0;
            tam = (int)personagens.size();

            //cout << "Tamanho da excluso: " << tam << endl;

            /*itPersonagens = personagens.begin();
            for (int i = 0; i < tam; i++)
            {
                    cout << "Endereo de memria: " << *itPersonagens << endl;
                    itPersonagens++;
            }*/

            if ( ( idx >= 0 ) && ( idx < tam ) )
            {
                itPersonagens = personagens.begin();

                //cout << "IDX da excluso: " << idx << endl;

                for (int i = 0; i < idx; i++)
                {
                    itPersonagens++;
                    //cout << "Endereo de memria: " << *itPersonagens << endl;
                }


                Personagem* p = NULL;
                p = *itPersonagens;

                if (p)
                {
                    personagens.erase(itPersonagens);
                }
                else
                {
                    cout << "Ponteiro nulo na remoo." << endl;
                }


                return p;
            }
            else
            {
                cout << "Excluso operando fora dos limites." << endl;
                return NULL;
            }

        }
    };

    class Jogo
    {
    private:

        int quant_bt;

        VetorPersonagens vetPers;

    public:

        Jogo(int qbt = 1) : quant_bt (qbt), vetPers ( )
        {

            Personagem::setMAX(30);

            Curupira* pCur = NULL;
            pCur = new Curupira ();
            vetPers.inserir(static_cast<Personagem*>(pCur));

            BoiTata* pBT = NULL;

            for ( int i = 0; i < quant_bt; i++ )
            {
                pBT = new BoiTata(pCur, i);
                pBT->setX(i);
                vetPers.inserir(static_cast<Personagem*>(pBT));
            }

            executar();
        }

        ~Jogo()
        {
            int total = quant_bt + 1;

            Personagem* pP = NULL;

            for (int i = 0; i < total; i++)
            {
                  pP = vetPers.excluir(0);

                  if (pP)
                  {
                     delete pP;
                  }
                  else
                  {
                      cout << "No se pode deletar ponteiro nulo." << endl;
                  }
            }
        }

        void executar()
        {
            int total = quant_bt + 1;
            Personagem* pP = NULL;

            cout << "Entrou." << endl;

            for (int j = 0; j < Personagem::getMAX(); j++)
            {
                for (int i = 0; i < total; i++)
                {
                    pP = vetPers[i];
                    pP->movimentar();
                }
            }

            //cout << "Movimentou." << endl;

            Curupira* pCur = NULL;
            pP = vetPers[0];
            pCur = static_cast<Curupira*>(pP);
            cout << "O valor de vidas do Curupira : " << pCur->getNVidas() << endl;
            cout << endl;

            BoiTata* pBT = NULL;
            for (int i = 1; i < total; i++)
            {
                  pP = vetPers[i];
                  pBT = static_cast<BoiTata*>(pP);

                  cout << " O " << i << ". Boi Tata tem o seguinte valor de energia: " << pBT->getEnergia() << endl;
            }
        }
    };
}

using namespace Gerenciadores;

int main()
{
    Jogo jogo(3);

    return 0;
}

